-- phpMyAdmin SQL Dump 
-- version 2.6.0-pl2
-- http://www.phpmyadmin.net
-- 
-- Host: localhost
-- Generation Time: Mar 16, 2005 at 11:18 PM
-- Server version: 4.0.18
-- PHP Version: 4.3.6
-- 
-- Database: `network`
-- 

-- --------------------------------------------------------

-- 
-- Table structure for table `site_devices`
-- 

CREATE TABLE `site_devices` (
  `device_id` int(11) NOT NULL auto_increment,
  `device_name` varchar(200) NOT NULL default '',
  `device_serial` varchar(200) NOT NULL default '',
  `device_other` varchar(200) NOT NULL default '',
  `device_location` int(11) NOT NULL default '0',
  `device_ports` text NOT NULL,
  `device_firmware` varchar(200) NOT NULL default '',
  `device_os` varchar(200) NOT NULL default '',
  `device_speed` varchar(200) NOT NULL default '',
  `device_mfg` int(11) NOT NULL default '0',
  `device_mfg_phone` varchar(50) NOT NULL default '',
  `device_mfg_site` varchar(200) NOT NULL default '',
  `device_mfg_link` varchar(200) NOT NULL default '',
  `device_type` int(11) NOT NULL default '0',
  `device_description` text NOT NULL,
  `device_purchase` int(11) NOT NULL default '0',
  `device_vendor` int(11) NOT NULL default '0',
  `device_warranty` varchar(200) NOT NULL default '',
  `device_network` int(11) NOT NULL default '0',
  `device_status` int(1) NOT NULL default '0',
  `device_date_online` int(11) NOT NULL default '0',
  `device_date_offline` int(11) NOT NULL default '0',
  `device_other2` text NOT NULL,
  PRIMARY KEY  (`device_id`)
) TYPE=MyISAM AUTO_INCREMENT=4 ;

-- 
-- Dumping data for table `site_devices`
-- 

INSERT INTO `site_devices` VALUES (1, '3Com Switch 4060', '4532', '4060', 13, '21', 'v1.5 beta 2', '3os', 'Gigabit EN - 10Base-T, 1000Base-SX, 100Base-TX, 1000Base-T', 14, '800-555-1312', 'http://www.3com.com', 'http://www.example.com', 22, 'High end switch for 2nd floor sales team.', 1109739600, 3, '12 months', 11, 1, 1109912400, -1, '');
INSERT INTO `site_devices` VALUES (2, 'PIX 506E', '23234324', '1', 12, '80,8080', '3.2', 'COS', '10/100', 6, '555-1212', 'http://www.cisco.com', 'http://ciscovendor.com', 20, 'Firewall for 1st floor offices. Very reliable, should reboot about every 3 months.', 1078981200, 3, '3 year with service contract', 10, 1, 1079326800, -1, '');
INSERT INTO `site_devices` VALUES (3, 'Netgear FVM318UK Wireless VPN Router', '45654', 'g', 8, '3389', '2.21', '', '54', 16, '555-1212', 'http://www.netgear.com', 'http://www.example.com', 21, 'Wireless router for CIO on 4th floor.', 1084248000, 1, '1 year', 11, 1, 1084334400, -1, 'Make sure this is always on, CIO doesn\\''t use it much, but if it\\''s down he calls right away.');

-- --------------------------------------------------------

-- 
-- Table structure for table `site_ip`
-- 

CREATE TABLE `site_ip` (
  `ip_id` int(11) NOT NULL auto_increment,
  `ip_device` int(11) NOT NULL default '0',
  `ip_ip` varchar(200) NOT NULL default '',
  `ip_gw` varchar(200) NOT NULL default '',
  `ip_ports` tinyint(4) NOT NULL default '0',
  `ip_nm` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`ip_id`)
) TYPE=MyISAM AUTO_INCREMENT=4 ;

-- 
-- Dumping data for table `site_ip`
-- 

INSERT INTO `site_ip` VALUES (1, 1, '172.20.100.10', '172.20.100.1', 0, '255.255.255.0');
INSERT INTO `site_ip` VALUES (2, 2, '192.168.1.222', '192.168.1.10', 80, '255.255.255.255');
INSERT INTO `site_ip` VALUES (3, 3, '192.168.1.5', '192.168.1.20', 0, '255.255.255.0');

-- --------------------------------------------------------

-- 
-- Table structure for table `site_log`
-- 

CREATE TABLE `site_log` (
  `note_id` int(11) NOT NULL auto_increment,
  `note_title` varchar(200) NOT NULL default '',
  `note_body` text NOT NULL,
  `note_relation` int(11) NOT NULL default '0',
  `note_type` int(1) NOT NULL default '0',
  `note_post_date` int(11) NOT NULL default '0',
  `note_post_ip` varchar(20) NOT NULL default '',
  `note_post_user` int(11) NOT NULL default '0',
  PRIMARY KEY  (`note_id`)
) TYPE=MyISAM AUTO_INCREMENT=2 ;

-- 
-- Dumping data for table `site_log`
-- 

INSERT INTO `site_log` VALUES (1, 'upgrade 3', 'Upgraded to 3.4', 1, 0, 1110641499, '127.0.0.1', 1);

-- --------------------------------------------------------

-- 
-- Table structure for table `site_mb_msg`
-- 

CREATE TABLE `site_mb_msg` (
  `msg_id` int(11) NOT NULL auto_increment,
  `msg_type` int(1) NOT NULL default '0',
  `msg_user` int(11) NOT NULL default '0',
  `msg_date` int(11) NOT NULL default '0',
  `msg_title` varchar(200) NOT NULL default '',
  `msg_from` int(11) NOT NULL default '0',
  `msg_to` int(11) NOT NULL default '0',
  `msg_body` longtext NOT NULL,
  `msg_new` int(1) NOT NULL default '0',
  `msg_delete` int(1) NOT NULL default '0',
  PRIMARY KEY  (`msg_id`)
) TYPE=MyISAM AUTO_INCREMENT=102 ;

-- 
-- Dumping data for table `site_mb_msg`
-- 

INSERT INTO `site_mb_msg` VALUES (100, 1, 1003, 1111030479, 'Joe', 1005, 1003, 'Joe, I noticed the lights were off on the firewall and no one can get out to the internet? Could that be a problem?', 0, 0);
INSERT INTO `site_mb_msg` VALUES (101, 2, 1005, 1111030479, 'Joe', 1005, 1003, 'Joe, I noticed the lights were off on the firewall and no one can get out to the internet? Could that be a problem?', 0, 0);

-- --------------------------------------------------------

-- 
-- Table structure for table `site_notes`
-- 

CREATE TABLE `site_notes` (
  `note_id` int(11) NOT NULL auto_increment,
  `note_title` varchar(200) NOT NULL default '',
  `note_body` text NOT NULL,
  `note_relation` int(11) NOT NULL default '0',
  `note_type` int(1) NOT NULL default '0',
  `note_post_date` int(11) NOT NULL default '0',
  `note_post_ip` varchar(20) NOT NULL default '',
  `note_post_user` int(11) NOT NULL default '0',
  PRIMARY KEY  (`note_id`)
) TYPE=MyISAM AUTO_INCREMENT=4 ;

-- 
-- Dumping data for table `site_notes`
-- 

INSERT INTO `site_notes` VALUES (1, 'Spare', 'There are a few spare parts for this in the 2nd floor closet.', 1, 0, 1110640211, '127.0.0.1', 1);
INSERT INTO `site_notes` VALUES (2, 'Firmware', 'There is a security notice for the current fireware. We should upgrade.', 2, 0, 1111029415, '192.168.1.1', 1);
INSERT INTO `site_notes` VALUES (3, 'bug', 'Needs to be restarted about every 10 days.', 3, 0, 1111029707, '192.168.1.1', 1);

-- --------------------------------------------------------

-- 
-- Table structure for table `site_types`
-- 

CREATE TABLE `site_types` (
  `type_id` int(11) NOT NULL auto_increment,
  `type` int(1) NOT NULL default '0',
  `type_name` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`type_id`)
) TYPE=MyISAM AUTO_INCREMENT=30 ;

-- 
-- Dumping data for table `site_types`
-- 

INSERT INTO `site_types` VALUES (1, 4, 'CDW');
INSERT INTO `site_types` VALUES (2, 4, 'Dell');
INSERT INTO `site_types` VALUES (3, 4, 'ACME Networks');
INSERT INTO `site_types` VALUES (4, 3, 'Router');
INSERT INTO `site_types` VALUES (5, 3, 'Hub');
INSERT INTO `site_types` VALUES (6, 2, 'Cisco');
INSERT INTO `site_types` VALUES (7, 2, 'Linksys');
INSERT INTO `site_types` VALUES (8, 1, '4th Floor');
INSERT INTO `site_types` VALUES (9, 1, '3rd Floor');
INSERT INTO `site_types` VALUES (10, 5, 'Network 1');
INSERT INTO `site_types` VALUES (11, 5, 'Network 2');
INSERT INTO `site_types` VALUES (14, 2, '3 Com');
INSERT INTO `site_types` VALUES (12, 1, '1st Floor');
INSERT INTO `site_types` VALUES (13, 1, '2nd Floor');
INSERT INTO `site_types` VALUES (15, 2, 'Fastcomm');
INSERT INTO `site_types` VALUES (16, 2, 'Netgear');
INSERT INTO `site_types` VALUES (17, 2, 'Motorola');
INSERT INTO `site_types` VALUES (18, 2, 'SMC');
INSERT INTO `site_types` VALUES (19, 2, 'Level One');
INSERT INTO `site_types` VALUES (20, 3, 'Firewall');
INSERT INTO `site_types` VALUES (21, 3, 'Wireless Router');
INSERT INTO `site_types` VALUES (22, 3, 'Switch');
INSERT INTO `site_types` VALUES (23, 3, 'Repeater');
INSERT INTO `site_types` VALUES (24, 3, 'DSL Modem');
INSERT INTO `site_types` VALUES (25, 3, 'Modem');
INSERT INTO `site_types` VALUES (26, 4, 'Buy.com');
INSERT INTO `site_types` VALUES (27, 4, 'Tech Depot');
INSERT INTO `site_types` VALUES (28, 4, 'TigerDirect');
INSERT INTO `site_types` VALUES (29, 5, 'Remote Office West');

-- --------------------------------------------------------

-- 
-- Table structure for table `site_user_notes`
-- 

CREATE TABLE `site_user_notes` (
  `note_id` int(11) NOT NULL auto_increment,
  `note_title` varchar(200) NOT NULL default '',
  `note_body` text NOT NULL,
  `note_relation` int(11) NOT NULL default '0',
  `note_type` int(1) NOT NULL default '0',
  `note_post_date` int(11) NOT NULL default '0',
  `note_post_ip` varchar(20) NOT NULL default '',
  `note_post_user` int(11) NOT NULL default '0',
  PRIMARY KEY  (`note_id`)
) TYPE=MyISAM AUTO_INCREMENT=7 ;

-- 
-- Dumping data for table `site_user_notes`
-- 


-- --------------------------------------------------------

-- 
-- Table structure for table `site_users`
-- 

CREATE TABLE `site_users` (
  `user_id` int(11) NOT NULL auto_increment,
  `user_login` varchar(30) NOT NULL default '',
  `user_password` varchar(30) NOT NULL default '',
  `user_name` varchar(200) NOT NULL default '',
  `user_address` varchar(200) NOT NULL default '',
  `user_city` varchar(100) NOT NULL default '',
  `user_state` char(3) NOT NULL default '',
  `user_zip` varchar(20) NOT NULL default '',
  `user_country` char(3) NOT NULL default '',
  `user_phone` varchar(39) NOT NULL default '',
  `user_email` varchar(200) NOT NULL default '',
  `user_email2` varchar(200) NOT NULL default '',
  `user_im_aol` varchar(100) NOT NULL default '',
  `user_im_icq` varchar(100) NOT NULL default '',
  `user_im_msn` varchar(100) NOT NULL default '',
  `user_im_yahoo` varchar(100) NOT NULL default '',
  `user_im_other` varchar(200) NOT NULL default '',
  `user_status` int(1) NOT NULL default '0',
  `user_level` int(1) NOT NULL default '0',
  `user_pending` int(11) NOT NULL default '0',
  `user_date` int(11) NOT NULL default '0',
  `last_login` int(11) NOT NULL default '0',
  `last_ip` varchar(20) NOT NULL default '',
  `user_msg_send` int(1) NOT NULL default '0',
  `user_msg_subject` varchar(200) NOT NULL default '',
  `user_protect_delete` int(1) default '0',
  `user_protect_edit` int(11) NOT NULL default '0',
  PRIMARY KEY  (`user_id`)
) TYPE=MyISAM PACK_KEYS=0 AUTO_INCREMENT=1007 ;

-- 
-- Dumping data for table `site_users`
-- 

INSERT INTO `site_users` VALUES (1, 'admin', 'test', 'Site Admin', '', '', '', '', '', '', 'admin@example.com', 'companyname@example.com', '', '', '', '', '', 0, 0, 0, 0, 1111031128, '192.168.1.1', 0, 'New Message', 1, 0);
INSERT INTO `site_users` VALUES (1003, 'joe', 'test', 'Joe Tech', '', '', '', '', '', '', 'jtech@example.com', 'techdept@example.com', 'aol', 'icq', 'msn', 'yahoo', 'other', 0, 1, 0, 1106772292, 1111032943, '192.168.1.1', 1, 'New Network Message', 0, 0);
INSERT INTO `site_users` VALUES (1006, 'Jane', 'test', 'Jane Tech', '', '', '', '', '', '', 'jane@example.com', 'dept@example.com', '', '', '', '', '', 0, 1, 0, 1111032669, 0, '', 0, '', 0, 0);
INSERT INTO `site_users` VALUES (1005, 'User', 'test', 'R Only', '', '', '', '', '', '', 'test@example.com', 'noone@example.com', '', '', '', '', '', 0, 2, 0, 1110646824, 1111030375, '192.168.1.1', 0, '', 0, 0);

-- --------------------------------------------------------

-- 
-- Table structure for table `site_vars`
-- 

CREATE TABLE `site_vars` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(200) NOT NULL default '',
  `value` text NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=44 ;

-- 
-- Dumping data for table `site_vars`
-- 

